Index: /palm/trunk/SOURCE/diffusion_v.f90
===================================================================
--- /palm/trunk/SOURCE/diffusion_v.f90	(revision 1014)
+++ /palm/trunk/SOURCE/diffusion_v.f90	(revision 1015)
@@ -4,5 +4,5 @@
 ! Current revisions:
 ! -----------------
-!
+! accelerator version (*_acc) added
 !
 ! Former revisions:
@@ -56,5 +56,5 @@
 
     PRIVATE
-    PUBLIC diffusion_v
+    PUBLIC diffusion_v, diffusion_v_acc
 
     INTERFACE diffusion_v
@@ -62,4 +62,8 @@
        MODULE PROCEDURE diffusion_v_ij
     END INTERFACE diffusion_v
+
+    INTERFACE diffusion_v_acc
+       MODULE PROCEDURE diffusion_v_acc
+    END INTERFACE diffusion_v_acc
 
  CONTAINS
@@ -218,4 +222,188 @@
 
 !------------------------------------------------------------------------------!
+! Call for all grid points - accelerator version
+!------------------------------------------------------------------------------!
+    SUBROUTINE diffusion_v_acc
+
+       USE arrays_3d
+       USE control_parameters
+       USE grid_variables
+       USE indices
+
+       IMPLICIT NONE
+
+       INTEGER ::  i, j, k
+       REAL    ::  kmxm, kmxp, kmzm, kmzp
+
+       !$acc declare create ( vsus )
+       REAL, DIMENSION(nzb:nzt+1,nys:nyn,nxl:nxr) ::  vsus
+
+!
+!--    First calculate horizontal momentum flux v'u' at vertical walls,
+!--    if neccessary
+       IF ( topography /= 'flat' )  THEN
+          CALL wall_fluxes_acc( vsus, 0.0, 1.0, 0.0, 0.0, nzb_v_inner, &
+                                nzb_v_outer, wall_v )
+       ENDIF
+
+       !$acc kernels present ( u, v, w, km, tend, vsws, vswst )   &
+       !$acc         present ( ddzu, ddzw, fxm, fxp, wall_v )           &
+       !$acc         present ( nzb_v_inner, nzb_v_outer, nzb_diff_v )
+       !$acc loop
+       DO  i = nxl, nxr
+          DO  j = nysv, nyn
+!
+!--          Compute horizontal diffusion
+             !$acc loop vector(32)
+             DO  k = 1, nzt
+                IF ( k > nzb_v_outer(j,i) )  THEN
+!
+!--                Interpolate eddy diffusivities on staggered gridpoints
+                   kmxp = 0.25 * &
+                          ( km(k,j,i)+km(k,j,i+1)+km(k,j-1,i)+km(k,j-1,i+1) )
+                   kmxm = 0.25 * &
+                          ( km(k,j,i)+km(k,j,i-1)+km(k,j-1,i)+km(k,j-1,i-1) )
+
+                   tend(k,j,i) = tend(k,j,i)                                   &
+                         & + ( kmxp * ( v(k,j,i+1) - v(k,j,i)     ) * ddx      &
+                         &   + kmxp * ( u(k,j,i+1) - u(k,j-1,i+1) ) * ddy      &
+                         &   - kmxm * ( v(k,j,i) - v(k,j,i-1) ) * ddx          &
+                         &   - kmxm * ( u(k,j,i) - u(k,j-1,i) ) * ddy          &
+                         &   ) * ddx                                           &
+                         & + 2.0 * (                                           &
+                         &           km(k,j,i)   * ( v(k,j+1,i) - v(k,j,i) )   &
+                         &         - km(k,j-1,i) * ( v(k,j,i) - v(k,j-1,i) )   &
+                         &         ) * ddy2
+                ENDIF
+             ENDDO
+
+!
+!--          Wall functions at the left and right walls, respectively
+             !$acc loop vector(32)
+             DO  k = 1, nzt
+                IF( k > nzb_v_inner(j,i)  .AND.  k <= nzb_v_outer(j,i)  .AND. &
+                    wall_v(j,i) /= 0.0 )  THEN
+
+                   kmxp = 0.25 * &
+                          ( km(k,j,i)+km(k,j,i+1)+km(k,j-1,i)+km(k,j-1,i+1) )
+                   kmxm = 0.25 * &
+                          ( km(k,j,i)+km(k,j,i-1)+km(k,j-1,i)+km(k,j-1,i-1) )
+                   
+                   tend(k,j,i) = tend(k,j,i)                                   &
+                                 + 2.0 * (                                     &
+                                       km(k,j,i)   * ( v(k,j+1,i) - v(k,j,i) ) &
+                                     - km(k,j-1,i) * ( v(k,j,i) - v(k,j-1,i) ) &
+                                         ) * ddy2                              &
+                                 + (   fxp(j,i) * (                            &
+                                  kmxp * ( v(k,j,i+1) - v(k,j,i)     ) * ddx   &
+                                + kmxp * ( u(k,j,i+1) - u(k,j-1,i+1) ) * ddy   &
+                                                  )                            &
+                                     - fxm(j,i) * (                            &
+                                  kmxm * ( v(k,j,i) - v(k,j,i-1) ) * ddx       &
+                                + kmxm * ( u(k,j,i) - u(k,j-1,i) ) * ddy       &
+                                                  )                            &
+                                     + wall_v(j,i) * vsus(k,j,i)               &
+                                   ) * ddx
+                ENDIF
+             ENDDO
+
+!
+!--          Compute vertical diffusion. In case of simulating a Prandtl
+!--          layer, index k starts at nzb_v_inner+2.
+             !$acc loop vector(32)
+             DO  k = 1, nzt_diff
+                IF ( k >= nzb_diff_v(j,i) )  THEN
+!
+!--                Interpolate eddy diffusivities on staggered gridpoints
+                   kmzp = 0.25 * &
+                          ( km(k,j,i)+km(k+1,j,i)+km(k,j-1,i)+km(k+1,j-1,i) )
+                   kmzm = 0.25 * &
+                          ( km(k,j,i)+km(k-1,j,i)+km(k,j-1,i)+km(k-1,j-1,i) )
+
+                   tend(k,j,i) = tend(k,j,i)                                   &
+                         & + ( kmzp * ( ( v(k+1,j,i) - v(k,j,i)   ) * ddzu(k+1)&
+                         &            + ( w(k,j,i)   - w(k,j-1,i) ) * ddy      &
+                         &            )                                        &
+                         &   - kmzm * ( ( v(k,j,i)   - v(k-1,j,i)   ) * ddzu(k)&
+                         &            + ( w(k-1,j,i) - w(k-1,j-1,i) ) * ddy    &
+                         &            )                                        &
+                         &   ) * ddzw(k)
+                ENDIF
+             ENDDO
+
+          ENDDO
+       ENDDO
+
+!
+!--    Vertical diffusion at the first grid point above the surface,
+!--    if the momentum flux at the bottom is given by the Prandtl law
+!--    or if it is prescribed by the user.
+!--    Difference quotient of the momentum flux is not formed over
+!--    half of the grid spacing (2.0*ddzw(k)) any more, since the
+!--    comparison with other (LES) modell showed that the values of
+!--    the momentum flux becomes too large in this case.
+!--    The term containing w(k-1,..) (see above equation) is removed here
+!--    because the vertical velocity is assumed to be zero at the surface.
+       IF ( use_surface_fluxes )  THEN
+
+          !$acc loop
+          DO  i = nxl, nxr
+             !$acc loop vector(32)
+             DO  j = nysv, nyn
+          
+                k = nzb_v_inner(j,i)+1
+!
+!--             Interpolate eddy diffusivities on staggered gridpoints
+                kmzp = 0.25 * &
+                       ( km(k,j,i)+km(k+1,j,i)+km(k,j-1,i)+km(k+1,j-1,i) )
+                kmzm = 0.25 * &
+                       ( km(k,j,i)+km(k-1,j,i)+km(k,j-1,i)+km(k-1,j-1,i) )
+
+                tend(k,j,i) = tend(k,j,i)                                    &
+                      & + ( kmzp * ( w(k,j,i) - w(k,j-1,i)     ) * ddy       &
+                      &   ) * ddzw(k)                                        &
+                      & + ( kmzp * ( v(k+1,j,i) - v(k,j,i)     ) * ddzu(k+1) &
+                      &   + vsws(j,i)                                        &
+                      &   ) * ddzw(k)
+             ENDDO
+          ENDDO
+
+       ENDIF
+
+!
+!--    Vertical diffusion at the first gridpoint below the top boundary,
+!--    if the momentum flux at the top is prescribed by the user
+       IF ( use_top_fluxes  .AND.  constant_top_momentumflux )  THEN
+
+          k = nzt
+
+          !$acc loop
+          DO  i = nxl, nxr
+             !$acc loop vector(32)
+             DO  j = nysv, nyn
+
+!
+!--             Interpolate eddy diffusivities on staggered gridpoints
+                kmzp = 0.25 * &
+                       ( km(k,j,i)+km(k+1,j,i)+km(k,j-1,i)+km(k+1,j-1,i) )
+                kmzm = 0.25 * &
+                       ( km(k,j,i)+km(k-1,j,i)+km(k,j-1,i)+km(k-1,j-1,i) )
+
+                tend(k,j,i) = tend(k,j,i)                                    &
+                      & - ( kmzm *  ( w(k-1,j,i) - w(k-1,j-1,i) ) * ddy      &
+                      &   ) * ddzw(k)                                        &
+                      & + ( -vswst(j,i)                                      &
+                      &   - kmzm * ( v(k,j,i)   - v(k-1,j,i)    ) * ddzu(k)  &
+                      &   ) * ddzw(k)
+             ENDDO
+          ENDDO
+
+       ENDIF
+       !$acc end kernels
+
+    END SUBROUTINE diffusion_v_acc
+
+
+!------------------------------------------------------------------------------!
 ! Call for grid point i,j
 !------------------------------------------------------------------------------!
Index: /palm/trunk/SOURCE/diffusion_w.f90
===================================================================
--- /palm/trunk/SOURCE/diffusion_w.f90	(revision 1014)
+++ /palm/trunk/SOURCE/diffusion_w.f90	(revision 1015)
@@ -4,5 +4,5 @@
 ! Current revisions:
 ! -----------------
-!
+! accelerator version (*_acc) added
 !
 ! Former revisions:
@@ -50,5 +50,5 @@
 
     PRIVATE
-    PUBLIC diffusion_w
+    PUBLIC diffusion_w, diffusion_w_acc
 
     INTERFACE diffusion_w
@@ -56,4 +56,8 @@
        MODULE PROCEDURE diffusion_w_ij
     END INTERFACE diffusion_w
+
+    INTERFACE diffusion_w_acc
+       MODULE PROCEDURE diffusion_w_acc
+    END INTERFACE diffusion_w_acc
 
  CONTAINS
@@ -170,4 +174,124 @@
 
 !------------------------------------------------------------------------------!
+! Call for all grid points - accelerator version
+!------------------------------------------------------------------------------!
+    SUBROUTINE diffusion_w_acc
+
+       USE arrays_3d
+       USE control_parameters
+       USE grid_variables
+       USE indices
+
+       IMPLICIT NONE
+
+       INTEGER ::  i, j, k
+       REAL    ::  kmxm, kmxp, kmym, kmyp
+
+       !$acc declare create ( wsus, wsvs )
+       REAL, DIMENSION(nzb:nzt+1,nys:nyn,nxl:nxr) ::  wsus, wsvs
+
+
+!
+!--    First calculate horizontal momentum flux w'u' and/or w'v' at vertical
+!--    walls, if neccessary
+       IF ( topography /= 'flat' )  THEN
+          CALL wall_fluxes_acc( wsus, 0.0, 0.0, 0.0, 1.0, nzb_w_inner, &
+                                nzb_w_outer, wall_w_x )
+          CALL wall_fluxes_acc( wsvs, 0.0, 0.0, 1.0, 0.0, nzb_w_inner, &
+                                nzb_w_outer, wall_w_y )
+       ENDIF
+
+       !$acc kernels present ( u, v, w, km, tend, vsws, vswst )    &
+       !$acc         present ( ddzu, ddzw, fwxm, fwxp, fwym, fwyp, wall_w_x, wall_w_y )           &
+       !$acc         present ( nzb_w_inner, nzb_w_outer )
+       !$acc loop
+       DO  i = nxl, nxr
+          DO  j = nys, nyn
+             !$acc loop vector( 32 )
+             DO  k = 1, nzt
+                IF ( k > nzb_w_outer(j,i) )  THEN
+!
+!--                Interpolate eddy diffusivities on staggered gridpoints
+                   kmxp = 0.25 * &
+                          ( km(k,j,i)+km(k,j,i+1)+km(k+1,j,i)+km(k+1,j,i+1) )
+                   kmxm = 0.25 * &
+                          ( km(k,j,i)+km(k,j,i-1)+km(k+1,j,i)+km(k+1,j,i-1) )
+                   kmyp = 0.25 * &
+                          ( km(k,j,i)+km(k+1,j,i)+km(k,j+1,i)+km(k+1,j+1,i) )
+                   kmym = 0.25 * &
+                          ( km(k,j,i)+km(k+1,j,i)+km(k,j-1,i)+km(k+1,j-1,i) )
+
+                   tend(k,j,i) = tend(k,j,i)                                     &
+                         & + ( kmxp * ( w(k,j,i+1)   - w(k,j,i)   ) * ddx        &
+                         &   + kmxp * ( u(k+1,j,i+1) - u(k,j,i+1) ) * ddzu(k+1)  &
+                         &   - kmxm * ( w(k,j,i)   - w(k,j,i-1) ) * ddx          &
+                         &   - kmxm * ( u(k+1,j,i) - u(k,j,i)   ) * ddzu(k+1)    &
+                         &   ) * ddx                                             &
+                         & + ( kmyp * ( w(k,j+1,i)   - w(k,j,i)   ) * ddy        &
+                         &   + kmyp * ( v(k+1,j+1,i) - v(k,j+1,i) ) * ddzu(k+1)  &
+                         &   - kmym * ( w(k,j,i)   - w(k,j-1,i) ) * ddy          &
+                         &   - kmym * ( v(k+1,j,i) - v(k,j,i)   ) * ddzu(k+1)    &
+                         &   ) * ddy                                             &
+                         & + 2.0 * (                                             &
+                         &   km(k+1,j,i) * ( w(k+1,j,i) - w(k,j,i) ) * ddzw(k+1) &
+                         & - km(k,j,i)   * ( w(k,j,i)   - w(k-1,j,i) ) * ddzw(k) &
+                         &         ) * ddzu(k+1)
+                ENDIF
+             ENDDO
+
+!
+!--          Wall functions at all vertical walls, where necessary
+             !$acc loop vector( 32 )
+             DO  k = 1,nzt
+
+                IF ( k > nzb_w_inner(j,i)  .AND.  k <= nzb_w_outer(j,i)  .AND. &
+                     wall_w_x(j,i) /= 0.0  .AND.  wall_w_y(j,i) /= 0.0 )  THEN
+!
+!--                Interpolate eddy diffusivities on staggered gridpoints
+                   kmxp = 0.25 * &
+                          ( km(k,j,i)+km(k,j,i+1)+km(k+1,j,i)+km(k+1,j,i+1) )
+                   kmxm = 0.25 * &
+                          ( km(k,j,i)+km(k,j,i-1)+km(k+1,j,i)+km(k+1,j,i-1) )
+                   kmyp = 0.25 * &
+                          ( km(k,j,i)+km(k+1,j,i)+km(k,j+1,i)+km(k+1,j+1,i) )
+                   kmym = 0.25 * &
+                          ( km(k,j,i)+km(k+1,j,i)+km(k,j-1,i)+km(k+1,j-1,i) )
+
+                   tend(k,j,i) = tend(k,j,i)                                   &
+                                 + (   fwxp(j,i) * (                           &
+                            kmxp * ( w(k,j,i+1)   - w(k,j,i)   ) * ddx         &
+                          + kmxp * ( u(k+1,j,i+1) - u(k,j,i+1) ) * ddzu(k+1)   &
+                                                   )                           &
+                                     - fwxm(j,i) * (                           &
+                            kmxm * ( w(k,j,i)     - w(k,j,i-1) ) * ddx         &
+                          + kmxm * ( u(k+1,j,i)   - u(k,j,i)   ) * ddzu(k+1)   &
+                                                   )                           &
+                                     + wall_w_x(j,i) * wsus(k,j,i)             &
+                                   ) * ddx                                     &
+                                 + (   fwyp(j,i) * (                           &
+                            kmyp * ( w(k,j+1,i)   - w(k,j,i)   ) * ddy         &
+                          + kmyp * ( v(k+1,j+1,i) - v(k,j+1,i) ) * ddzu(k+1)   &
+                                                   )                           &
+                                     - fwym(j,i) * (                           &
+                            kmym * ( w(k,j,i)     - w(k,j-1,i) ) * ddy         &
+                          + kmym * ( v(k+1,j,i)   - v(k,j,i)   ) * ddzu(k+1)   &
+                                                   )                           &
+                                     + wall_w_y(j,i) * wsvs(k,j,i)             &
+                                   ) * ddy                                     &
+                                 + 2.0 * (                                     &
+                           km(k+1,j,i) * ( w(k+1,j,i) - w(k,j,i) ) * ddzw(k+1) &
+                         - km(k,j,i)   * ( w(k,j,i)   - w(k-1,j,i) ) * ddzw(k) &
+                                         ) * ddzu(k+1)
+                ENDIF
+             ENDDO
+
+          ENDDO
+       ENDDO
+       !$acc end kernels
+
+    END SUBROUTINE diffusion_w_acc
+
+
+!------------------------------------------------------------------------------!
 ! Call for grid point i,j
 !------------------------------------------------------------------------------!
Index: /palm/trunk/SOURCE/diffusivities.f90
===================================================================
--- /palm/trunk/SOURCE/diffusivities.f90	(revision 1014)
+++ /palm/trunk/SOURCE/diffusivities.f90	(revision 1015)
@@ -4,4 +4,7 @@
 ! Current revisions:
 ! -----------------
+! OpenACC statements added + code changes required for GPU optimization,
+! adjustment of mixing length to the Prandtl mixing length at first grid point
+! above ground removed
 ! 
 ! Former revisions:
@@ -52,11 +55,7 @@
     INTEGER ::  i, j, k, omp_get_thread_num, sr, tn
 
-    REAL    ::  dvar_dz, l_stable, var_reference
-
-    REAL, SAVE ::  phi_m = 1.0
+    REAL    ::  dvar_dz, l, ll, l_stable, sqrt_e, var_reference
 
     REAL    ::  var(nzb:nzt+1,nysg:nyng,nxlg:nxrg)
-
-    REAL, DIMENSION(1:nzt) ::  l, ll, sqrt_e
 
 
@@ -71,94 +70,90 @@
 !
 !-- Compute the turbulent diffusion coefficient for momentum
-    !$OMP PARALLEL PRIVATE (dvar_dz,i,j,k,l,ll,l_stable,phi_m,sqrt_e,sr,tn)
+    !$OMP PARALLEL PRIVATE (dvar_dz,i,j,k,l,ll,l_stable,sqrt_e,sr,tn)
 !$  tn = omp_get_thread_num()
 
+!
+!-- Data declerations for accelerators
+    !$acc data present( dd2zu, e, km, kh, l_grid, l_wall, nzb_s_inner, rif, var )
+    !$acc kernels
+
+!
+!-- Introduce an optional minimum tke
+    IF ( e_min > 0.0 )  THEN
+       !$OMP DO
+       !$acc loop
+       DO  i = nxlg, nxrg
+          DO  j = nysg, nyng
+             !$acc loop vector( 32 )
+             DO  k = 1, nzt
+                IF ( k > nzb_s_inner(j,i) )  THEN
+                   e(k,j,i) = MAX( e(k,j,i), e_min )
+                ENDIF
+             ENDDO
+          ENDDO
+       ENDDO
+    ENDIF
+
     !$OMP DO
+    !$acc loop
     DO  i = nxlg, nxrg
        DO  j = nysg, nyng
+          !$acc loop vector( 32 )
+          DO  k = 1, nzt
 
+             IF ( k > nzb_s_inner(j,i) )  THEN
+
+                sqrt_e = SQRT( e(k,j,i) )
 !
-!--       Compute the Phi-function for a possible adaption of the mixing length
-!--       to the Prandtl mixing length
-          IF ( adjust_mixing_length  .AND.  prandtl_layer )  THEN
-             IF ( rif(j,i) >= 0.0 )  THEN
-                phi_m = 1.0 + 5.0 * rif(j,i)
-             ELSE
-                phi_m = 1.0 / SQRT( SQRT( 1.0 - 16.0 * rif(j,i) ) )
-             ENDIF
-          ENDIF
-          
+!--             Determine the mixing length
+                dvar_dz = atmos_ocean_sign * &  ! inverse effect of pt/rho gradient
+                          ( var(k+1,j,i) - var(k-1,j,i) ) * dd2zu(k)
+                IF ( dvar_dz > 0.0 ) THEN
+                   IF ( use_reference )  THEN
+                      l_stable = 0.76 * sqrt_e / &
+                                 SQRT( g / var_reference * dvar_dz ) + 1E-5
+                   ELSE
+                      l_stable = 0.76 * sqrt_e / &
+                                 SQRT( g / var(k,j,i) * dvar_dz ) + 1E-5
+                   ENDIF
+                ELSE
+                   l_stable = l_grid(k)
+                ENDIF
 !
-!--       Introduce an optional minimum tke
-          IF ( e_min > 0.0 )  THEN
-             DO  k = nzb_s_inner(j,i)+1, nzt
-                e(k,j,i) = MAX( e(k,j,i), e_min )
-             ENDDO
-          ENDIF
+!--             Adjustment of the mixing length
+                IF ( wall_adjustment )  THEN
+                   l  = MIN( l_wall(k,j,i), l_grid(k), l_stable )
+                   ll = MIN( l_wall(k,j,i), l_grid(k) )
+                ELSE
+                   l  = MIN( l_grid(k), l_stable )
+                   ll = l_grid(k)
+                ENDIF
 
-!
-!--       Calculate square root of e in a seperate loop, because it is used
-!--       twice in the next loop (better vectorization)
-          DO  k = nzb_s_inner(j,i)+1, nzt
-             sqrt_e(k) = SQRT( e(k,j,i) )
-          ENDDO
+      !
+      !--       Compute diffusion coefficients for momentum and heat
+                km(k,j,i) = 0.1 * l * sqrt_e
+                kh(k,j,i) = ( 1.0 + 2.0 * l / ll ) * km(k,j,i)
 
-!
-!--       Determine the mixing length
-          DO  k = nzb_s_inner(j,i)+1, nzt
-             dvar_dz = atmos_ocean_sign * &  ! inverse effect of pt/rho gradient
-                       ( var(k+1,j,i) - var(k-1,j,i) ) * dd2zu(k)
-             IF ( dvar_dz > 0.0 ) THEN
-                IF ( use_reference )  THEN
-                   l_stable = 0.76 * sqrt_e(k) / &
-                                     SQRT( g / var_reference * dvar_dz ) + 1E-5
-                ELSE
-                   l_stable = 0.76 * sqrt_e(k) / &
-                                     SQRT( g / var(k,j,i) * dvar_dz ) + 1E-5
-                ENDIF
-             ELSE
-                l_stable = l_grid(k)
-             ENDIF
-!
-!--          Adjustment of the mixing length
-             IF ( wall_adjustment )  THEN
-                l(k)  = MIN( l_wall(k,j,i), l_grid(k), l_stable )
-                ll(k) = MIN( l_wall(k,j,i), l_grid(k) )
-             ELSE
-                l(k)  = MIN( l_grid(k), l_stable )
-                ll(k) = l_grid(k)
-             ENDIF
-             IF ( adjust_mixing_length  .AND.  prandtl_layer )  THEN
-                l(k)  = MIN( l(k),  kappa * &
-                                    ( zu(k) - zw(nzb_s_inner(j,i)) ) / phi_m )
-                ll(k) = MIN( ll(k), kappa * &
-                                    ( zu(k) - zw(nzb_s_inner(j,i)) ) / phi_m )
              ENDIF
 
+#if ! defined( __openacc )
 !
-!--          Compute diffusion coefficients for momentum and heat
-             km(k,j,i) = 0.1 * l(k) * sqrt_e(k)
-             kh(k,j,i) = ( 1.0 + 2.0 * l(k) / ll(k) ) * km(k,j,i)
+!++          Statistics still have to be realized for accelerators
+!--          Summation for averaged profile (cf. flow_statistics)
+             DO  sr = 0, statistic_regions
+                sums_l_l(k,sr,tn) = sums_l_l(k,sr,tn) + l * rmask(j,i,sr)
+             ENDDO
+#endif
 
           ENDDO
-
-!
-!--       Summation for averaged profile (cf. flow_statistics)
-!--       (the IF statement still requires a performance check on NEC machines)
-          DO  sr = 0, statistic_regions
-             IF ( rmask(j,i,sr) /= 0.0 .AND.  &
-                  i >= nxl .AND. i <= nxr .AND. j >= nys .AND. j <= nyn )  THEN
-                DO  k = nzb_s_inner(j,i)+1, nzt
-                   sums_l_l(k,sr,tn) = sums_l_l(k,sr,tn) + l(k)
-                ENDDO
-             ENDIF
-          ENDDO
-
        ENDDO
     ENDDO
 
+#if ! defined( __openacc )
+!
+!++ Statistics still have to be realized for accelerators
     sums_l_l(nzt+1,:,tn) = sums_l_l(nzt,:,tn)   ! quasi boundary-condition for
                                                   ! data output
-
+#endif
     !$OMP END PARALLEL
 
@@ -169,4 +164,5 @@
 !-- values of the diffusivities are not needed
     !$OMP PARALLEL DO
+    !$acc loop
     DO  i = nxlg, nxrg
        DO  j = nysg, nyng
@@ -198,4 +194,6 @@
     ENDIF
 
+    !$acc end kernels
+    !$acc end data
 
  END SUBROUTINE diffusivities
Index: /palm/trunk/SOURCE/header.f90
===================================================================
--- /palm/trunk/SOURCE/header.f90	(revision 1014)
+++ /palm/trunk/SOURCE/header.f90	(revision 1015)
@@ -4,5 +4,6 @@
 ! Current revisions:
 ! -----------------
-!
+! output of Aajustment of mixing length to the Prandtl mixing length at first
+! grid point above ground removed
 !
 ! Former revisions:
@@ -1482,5 +1483,4 @@
        IF ( e_min > 0.0 )  WRITE ( io, 454 )  e_min
        IF ( wall_adjustment )  WRITE ( io, 453 )  wall_adjustment_factor
-       IF ( adjust_mixing_length  .AND.  prandtl_layer )  WRITE ( io, 452 )
     ENDIF
 
@@ -1936,5 +1936,4 @@
 451 FORMAT ('    Diffusion coefficients are constant:'/ &
             '    Km = ',F6.2,' m**2/s   Kh = ',F6.2,' m**2/s   Pr = ',F5.2)
-452 FORMAT ('    Mixing length is limited to the Prandtl mixing lenth.')
 453 FORMAT ('    Mixing length is limited to ',F4.2,' * z')
 454 FORMAT ('    TKE is not allowed to fall below ',E9.2,' (m/s)**2')
Index: /palm/trunk/SOURCE/init_1d_model.f90
===================================================================
--- /palm/trunk/SOURCE/init_1d_model.f90	(revision 1014)
+++ /palm/trunk/SOURCE/init_1d_model.f90	(revision 1015)
@@ -4,5 +4,6 @@
 ! Current revisions:
 ! -----------------
-!
+! adjustment of mixing length to the Prandtl mixing length at first grid point
+! above ground removed
 !
 ! Former revisions:
@@ -113,12 +114,4 @@
           l_black(nzt+1) = l_black(nzt)
 
-       ENDIF
-
-!
-!--    Adjust mixing length to the prandtl mixing length (within the prandtl
-!--    layer)
-       IF ( adjust_mixing_length  .AND.  prandtl_layer )  THEN
-          k = nzb+1
-          l_black(k) = MIN( l_black(k), kappa * zu(k) )
        ENDIF
     ENDIF
@@ -603,17 +596,4 @@
 
 !
-!--          Adjust mixing length to the prandtl mixing length
-             IF ( adjust_mixing_length  .AND.  prandtl_layer )  THEN
-                k = nzb+1
-                IF ( rif1d(k) >= 0.0 )  THEN
-                   l1d(k) = MIN( l1d(k), kappa * zu(k) / ( 1.0 + 5.0 * &
-                                                           rif1d(k) ) )
-                ELSE
-                   l1d(k) = MIN( l1d(k), kappa * zu(k) *          &
-                                  SQRT( SQRT( 1.0 - 16.0 * rif1d(k) ) ) )
-                ENDIF
-             ENDIF
-
-!
 !--          Compute the diffusion coefficients for momentum via the
 !--          corresponding Prandtl-layer relationship and according to
Index: /palm/trunk/SOURCE/init_3d_model.f90
===================================================================
--- /palm/trunk/SOURCE/init_3d_model.f90	(revision 1014)
+++ /palm/trunk/SOURCE/init_3d_model.f90	(revision 1015)
@@ -7,5 +7,5 @@
 ! Current revisions:
 ! ------------------
-!
+! mask is set to zero for ghost boundaries
 !
 ! Former revisions:
@@ -1530,5 +1530,9 @@
 !
 !-- Pre-set masks for regional statistics. Default is the total model domain.
+!-- Ghost points are excluded because counting values at the ghost boundaries
+!-- would bias the statistics
     rmask = 1.0
+    rmask(nxlg:nxl-1,:,:) = 0.0;  rmask(nxr+1:nxrg,:,:) = 0.0
+    rmask(:,nysg:nys-1,:) = 0.0;  rmask(:,nyn+1:nyng,:) = 0.0
 
 !
Index: /palm/trunk/SOURCE/init_grid.f90
===================================================================
--- /palm/trunk/SOURCE/init_grid.f90	(revision 1014)
+++ /palm/trunk/SOURCE/init_grid.f90	(revision 1015)
@@ -4,5 +4,6 @@
 ! Current revisions:
 ! -----------------
-!
+! lower index for calculating wall_flags_0 set to nzb_w_inner instead of
+! nzb_w_inner+1
 !
 ! Former revisions:
@@ -1253,5 +1254,5 @@
        DO  i = nxl, nxr
           DO  j = nys, nyn
-             DO  k = nzb_w_inner(j,i)+1, nzt
+             DO  k = nzb_w_inner(j,i), nzt
 !
 !--             w component - x-direction
Index: /palm/trunk/SOURCE/modules.f90
===================================================================
--- /palm/trunk/SOURCE/modules.f90	(revision 1014)
+++ /palm/trunk/SOURCE/modules.f90	(revision 1015)
@@ -4,5 +4,6 @@
 ! Current revisions:
 ! -----------------
-!
+! +acc_rank, num_acc_per_node,
+! -adjust_mixing_length
 !
 ! Former revisions:
@@ -592,5 +593,5 @@
                 mask_i_global, mask_j_global, mask_k_global
 
-    LOGICAL ::  adjust_mixing_length = .FALSE., avs_output = .FALSE., &
+    LOGICAL ::  avs_output = .FALSE., &
                 bc_lr_cyc =.TRUE., bc_lr_dirneu = .FALSE., &
                 bc_lr_dirrad = .FALSE., bc_lr_neudir = .FALSE., &
@@ -1335,5 +1336,6 @@
 #endif
     CHARACTER(LEN=5)       ::  myid_char = ''
-    INTEGER                ::  id_inflow = 0, id_recycling = 0, myid = 0,      &
+    INTEGER                ::  acc_rank, id_inflow = 0, id_recycling = 0,      &
+                               myid = 0, num_acc_per_node = 0,                 &
                                target_id, npex = -1, npey = -1, numprocs = 1,  &
                                numprocs_previous_run = -1,                     &
Index: /palm/trunk/SOURCE/palm.f90
===================================================================
--- /palm/trunk/SOURCE/palm.f90	(revision 1014)
+++ /palm/trunk/SOURCE/palm.f90	(revision 1015)
@@ -4,5 +4,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! OpenACC statements added + code changes required for GPU optimization
 !
 ! Former revisions:
@@ -77,4 +77,8 @@
     USE statistics
 
+#if defined( __openacc )
+    USE OPENACC
+#endif
+
     IMPLICIT NONE
 
@@ -84,4 +88,7 @@
     CHARACTER (LEN=1) ::  cdum
     INTEGER           ::  i, run_description_header_i(80)
+#if defined( __openacc )
+    REAL, DIMENSION(100) ::  acc_dum
+#endif
 
     version = 'PALM 3.8a'
@@ -102,4 +109,23 @@
 #endif
 
+#if defined( __openacc )
+!
+!-- Get the number of accelerator boards per node and assign the MPI processes
+!-- to these boards
+    num_acc_per_node  = ACC_GET_NUM_DEVICES( ACC_DEVICE_NVIDIA )
+    acc_rank = MOD( myid, num_acc_per_node )
+    CALL ACC_SET_DEVICE_NUM ( acc_rank, ACC_DEVICE_NVIDIA )
+!
+!-- Test output (to be removed later)
+    WRITE (*,'(A,I4,A,I3,A,I3,A,I3)') '*** Connect MPI-Task ', myid,' to CPU ',&
+                                      acc_rank, ' Devices: ', num_acc_per_node,&
+                                      ' connected to:',                        &
+                                      ACC_GET_DEVICE_NUM( ACC_DEVICE_NVIDIA )
+#endif
+!
+!-- Ensure that OpenACC first attaches the GPU devices by copying a dummy data
+!-- region
+    !$acc data copyin( acc_dum )
+
 !
 !-- Initialize measuring of the CPU-time remaining to the run
@@ -177,4 +203,14 @@
     ENDIF
 
+!
+!-- Declare and initialize variables in the accelerator memory with their
+!-- host values
+    !$acc  data copyin( diss, e, e_p, kh, km, pt, pt_p, q, ql, tend, te_m, tpt_m, tu_m, tv_m, tw_m, u, u_p, v, vpt, v_p, w, w_p )          &
+    !$acc       copyin( ddzu, ddzw, dd2zu, l_grid, l_wall, ptdf_x, ptdf_y, pt_init, rdf, rdf_sc, ug, vg, zu, zw )   &
+    !$acc       copyin( hom, qs, qsws, qswst, rif, rif_wall, shf, ts, tswst, us, usws, uswst, vsws, vswst, z0, z0h )      &
+    !$acc       copyin( fxm, fxp, fym, fyp, fwxm, fwxp, fwym, fwyp, nzb_diff_s_inner, nzb_diff_s_outer, nzb_diff_u )       &
+    !$acc       copyin( nzb_diff_v, nzb_s_inner, nzb_s_outer, nzb_u_inner )    &
+    !$acc       copyin( nzb_u_outer, nzb_v_inner, nzb_v_outer, nzb_w_inner )   &
+    !$acc       copyin( nzb_w_outer, wall_heatflux, wall_e_x, wall_e_y, wall_u, wall_v, wall_w_x, wall_w_y, wall_flags_0 )
 !
 !-- Integration of the model equations using timestep-scheme
@@ -242,4 +278,9 @@
 
 !
+!-- Close the OpenACC dummy data region
+    !$acc end data
+    !$acc end data
+
+!
 !-- Take final CPU-time for CPU-time analysis
     CALL cpu_log( log_point(1), 'total', 'stop' )
Index: /palm/trunk/SOURCE/parin.f90
===================================================================
--- /palm/trunk/SOURCE/parin.f90	(revision 1014)
+++ /palm/trunk/SOURCE/parin.f90	(revision 1015)
@@ -4,5 +4,5 @@
 ! Current revisions:
 ! -----------------
-!
+! -adjust_mixing_length
 !
 ! Former revisions:
@@ -164,5 +164,5 @@
 
 
-    NAMELIST /inipar/  adjust_mixing_length, alpha_surface, bc_e_b, bc_lr, &
+    NAMELIST /inipar/  alpha_surface, bc_e_b, bc_lr, &
                        bc_ns, bc_p_b, bc_p_t, bc_pt_b, bc_pt_t, bc_q_b, &
              bc_q_t,bc_s_b, bc_s_t, bc_sa_t, bc_uv_b, bc_uv_t, &
